with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.ISVGPoint_Interface is

   procedure Initialize (This : in out ISVGPoint_Type) is
   begin
      Set_IID (This, IID_ISVGPoint);
   end Initialize;

   function Pointer (This : ISVGPoint_Type)
     return Pointer_To_ISVGPoint
   is
   begin
      return To_Pointer_To_ISVGPoint (Address (This));
   end Pointer;

   procedure Attach (This    : in out ISVGPoint_Type;
                     Pointer : in     Pointer_To_ISVGPoint)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_x
     (This : ISVGPoint_Type;
      p    : Interfaces.C.C_float)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_x
         (Pointer (This),
          p));

   end Put_x;

   function Get_x
     (This : ISVGPoint_Type)
     return Interfaces.C.C_float
   is
       RetVal : aliased Interfaces.C.C_float;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_x
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_x;

   procedure Put_y
     (This : ISVGPoint_Type;
      p    : Interfaces.C.C_float)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_y
         (Pointer (This),
          p));

   end Put_y;

   function Get_y
     (This : ISVGPoint_Type)
     return Interfaces.C.C_float
   is
       RetVal : aliased Interfaces.C.C_float;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_y
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_y;

   function matrixTransform
     (This     : ISVGPoint_Type;
      pMatrix  : Pointer_To_ISVGMatrix)
     return Pointer_To_ISVGPoint
   is
       RetVal : aliased Pointer_To_ISVGPoint;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.matrixTransform
         (Pointer (This),
          pMatrix,
          RetVal'Unchecked_Access));

      return RetVal;
   end matrixTransform;

end MSHTML.ISVGPoint_Interface;

